<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="账户号" prop="cardAccount">
        <el-input
          v-model="queryParams.cardAccount"
          placeholder="请输入账户号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="账户名称" prop="cardName">
        <el-input
          v-model="queryParams.cardName"
          placeholder="请输入账户名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['cai:accountBlack:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['cai:accountBlack:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['cai:accountBlack:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
            type="info"
            plain
            icon="el-icon-upload2"
            size="mini"
            @click="handleImport"
            v-hasPermi="['cai:accountBlack:import']"
        >导入</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
            type="warning"
            plain
            icon="el-icon-download"
            size="mini"
            @click="handleExport"
            v-hasPermi="['cai:accountBlack:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="accountBlackList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="id" align="center" prop="id" v-if="true"/>
      <el-table-column label="账户号" align="center" prop="cardAccount" />
      <el-table-column label="账户名称" align="center" prop="cardName" />
      <el-table-column label="是否开启" align="center" prop="enableStatus">
        <template v-slot="scope">
          <el-switch
              v-model="scope.row.enableStatus"
              :active-value="1"
              :inactive-value="0"
              @change="handleStatusChange(scope.row)"
          ></el-switch>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template v-slot="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['cai:accountBlack:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['cai:accountBlack:remove']"
          >删除</el-button>
          <el-button
              size="mini"
              type="text"
              @click="handleUser(scope.row)"
          >命中用户</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 用户导入对话框 -->
    <el-dialog :title="upload.title" :visible.sync="upload.open" width="400px" append-to-body>
      <el-upload
          ref="upload"
          :limit="1"
          accept=".xlsx, .xls"
          :headers="upload.headers"
          :action="upload.url + '?updateSupport=' + upload.updateSupport"
          :disabled="upload.isUploading"
          :on-progress="handleFileUploadProgress"
          :on-success="handleFileSuccess"
          :auto-upload="false"
          drag
      >
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">将文件拖到此处，或<em>点击上传</em></div>
        <div class="el-upload__tip text-center" slot="tip">
          <span>仅允许导入xls、xlsx格式文件。</span>
          <el-link type="primary" :underline="false" style="font-size:12px;vertical-align: baseline;" @click="importTemplate">下载模板</el-link>
        </div>
      </el-upload>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitFileForm">确 定</el-button>
        <el-button @click="upload.open = false">取 消</el-button>
      </div>
    </el-dialog>

    <account-black-add-update-dialog v-if="accountBlackAddUpdateDialogVisible" ref="accountBlackAddUpdateDialog" @refreshDataList="getList" />
    <account-black-user-dialog v-if="accountBlackUserDialogVisible" ref="accountBlackUserDialog" />
  </div>
</template>

<script>
import {delAccountBlack, listAccountBlack, updateAccountBlack} from "@/api/cai/accountBlack";
import AccountBlackAddUpdateDialog from "@/views/cai/accountBlack/account-black-add-update-dialog.vue";
import AccountBlackUserDialog from "@/views/cai/accountBlack/account-black-user-dialog.vue";
import {getToken} from "@/utils/auth";
export default {
  name: "AccountBlack",
  components: {AccountBlackAddUpdateDialog,AccountBlackUserDialog},
  data() {
    return {
      accountBlackAddUpdateDialogVisible: false,
      accountBlackUserDialogVisible: false,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 账户黑名单表格数据
      accountBlackList: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        cardAccount: undefined,
        cardName: undefined,
      },
      // 用户导入参数
      upload: {
        // 是否显示弹出层（用户导入）
        open: false,
        // 弹出层标题（用户导入）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 设置上传的请求头部
        headers: { Authorization: "Bearer " + getToken() },
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/cai/accountBlack/importData"
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询账户黑名单列表 */
    getList() {
      this.loading = true;
      listAccountBlack(this.queryParams).then(response => {
        this.accountBlackList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    handleUser(row){
      this.accountBlackUserDialogVisible = true
      this.$nextTick(() => {
        this.$refs.accountBlackUserDialog.init(row)
      })
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.accountBlackAddUpdateDialogVisible = true
      this.$nextTick(() => {
        this.$refs.accountBlackAddUpdateDialog.init()
      })
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.accountBlackAddUpdateDialogVisible = true
      this.$nextTick(() => {
        this.$refs.accountBlackAddUpdateDialog.init(row.id)
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除账户黑名单编号为"' + ids + '"的数据项？').then(() => {
        this.loading = true;
        return delAccountBlack(ids);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
    handleStatusChange(row){
      let text = row.enableStatus === 1 ? '开启' : '关闭'
      this.$confirm('确认要' + text + '[' + row.cardName + ']账号黑名单吗?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        return updateAccountBlack({ id: row.id, enableStatus: row.enableStatus })
      }).then(() => {
        this.$modal.msgSuccess(text + '成功')
      }).catch(function() {
        console.log("操作失败")
        row.enableStatus = row.enableStatus === 0 ? 1 : 0
      })
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('cai/accountBlack/export', {
        ...this.queryParams
      }, `黑名单_${new Date().getTime()}.xlsx`)
    },
    /** 导入按钮操作 */
    handleImport() {
      this.upload.title = "用户黑名单导入";
      this.upload.open = true;
    },
    /** 下载模板操作 */
    importTemplate() {
      this.download('cai/accountBlack/importTemplate', {
      }, `黑名单_模板.xlsx`)
    },
    // 文件上传中处理
    handleFileUploadProgress(event, file, fileList) {
      this.upload.isUploading = true;
    },
    // 文件上传成功处理
    handleFileSuccess(response, file, fileList) {
      this.upload.open = false;
      this.upload.isUploading = false;
      this.$refs.upload.clearFiles();
      this.$alert("<div style='overflow: auto;overflow-x: hidden;max-height: 70vh;padding: 10px 20px 0;'>" + response.msg + "</div>", "导入结果", { dangerouslyUseHTMLString: true });
      this.getList();
    },
    // 提交上传文件
    submitFileForm() {
      this.$refs.upload.submit();
    }
  }
};
</script>
